<nz-spin [nzSpinning]="isLoading">
  <app-main-layout [title]="fullEvent | eventFullName" [breadCrumbs]="['Évènement', 'détail']"
                   [tag]="fullEvent?.event?.state | eventState"
                   [subTitle]="fullEvent?.event?.startDate?.toDate() | date:'dd/MM/yyyy à HH:mm'">
    <ng-container *ngIf="!isLoading && fullEvent">
      <nz-tabset>
        <nz-tab nzTitle="Informations">
          <ng-template nz-tab>
            <nz-row>
              <nz-col [nzSpan]="12">
                <nz-card>
                  <nz-statistic
                    [nzValue]="(fullEvent?.event?.startDate?.toDate() | date:'dd/MM/yyyy à HH:mm')"
                    [nzTitle]="'Début'"
                    [nzPrefix]="prefixTplOne"
                  >
                  </nz-statistic>
                  <ng-template #prefixTplOne>
                    <i nz-icon nzType="clock-circle" nzTheme="twotone"></i>
                  </ng-template>
                </nz-card>
              </nz-col>
              <nz-col [nzSpan]="12" *ngIf="fullEvent?.event?.available">
                <nz-card>
                  <nz-statistic
                    [nzValue]="fullEvent.event.available"
                    [nzTitle]="'Places disponibles'"
                    [nzPrefix]="prefixTplTwo"
                  >
                  </nz-statistic>
                  <ng-template #prefixTplTwo>
                    <i nz-icon nzType="team"></i>
                  </ng-template>
                </nz-card>
              </nz-col>
              <nz-col [nzSpan]="12" *ngIf="fullEvent?.event?.camLink">
                <nz-card>
                  <nz-statistic
                    [nzValue]="fullEvent.event.camLink"
                    [nzTitle]="'Id Réunion'"
                    [nzPrefix]="prefixTplFour"
                  >
                  </nz-statistic>
                  <ng-template #prefixTplFour>
                    <i nz-icon nzType="video-camera" nzTheme="twotone" [nzTwotoneColor]="'#eb2f96'"></i>
                  </ng-template>
                </nz-card>
              </nz-col>

            </nz-row>
            <nz-row>
              <nz-col [nzSpan]="24" *ngIf="fullEvent?.event?.camLink">
                <nz-card>
                  <a nz-button
                     nzShape="round"
                     nzSize="large" nzType="primary"
                     style="width: 300px; height: 45px; padding: 0"
                     [href]="fullEvent?.event?.link" type="link" target="_blank">
                    <i nz-icon nzType="video-camera" nzTheme="outline"></i>
                    Rejoindre
                  </a>
                </nz-card>
              </nz-col>
            </nz-row>

          </ng-template>
        </nz-tab>
        <nz-tab *ngIf="user?.isAdmin || user?.isManager" nzTitle="Participants">
          <ng-template nz-tab>
            <div nz-row>
              <div nz-col nzSpan="24">
                <form nz-form nzLayout="vertical" [formGroup]="searchUserForm">
                  <nz-form-item>
                    <nz-form-label>Ajouter un patient</nz-form-label>
                    <nz-form-control>
                      <input placeholder="Rechercher" nz-input formControlName="value"
                             [nzAutocomplete]="auto"/>
                      <nz-autocomplete #auto [nzBackfill]="true">
                        <nz-auto-option
                          *ngFor="let user of usersList"
                          [nzValue]="user"
                          [nzLabel]="user.lastName + ' ' + user.firstName"
                        >
                          {{ user.lastName }} {{ user.firstName }}
                        </nz-auto-option>
                      </nz-autocomplete>
                    </nz-form-control>
                  </nz-form-item>

                  <nz-form-item>
                    <nz-form-control>
                      <button type="button" [disabled]="searchUserForm.get('value').invalid" nz-button nzType="primary"
                              (click)="addUserToAnEvent()">Ajouter
                      </button>
                    </nz-form-control>
                  </nz-form-item>
                </form>
              </div>
            </div>
            <div nz-row>
              <div nz-col nzSpan="24">
                <app-cruder [service]="invitedService" type="isUser" [other]="fullEvent?.event"></app-cruder>
              </div>
            </div>
          </ng-template>
        </nz-tab>
        <nz-tab nzTitle="Animateurs">
          <ng-template nz-tab>
            <div nz-row *ngIf="user?.isManager || user?.isAdmin">
              <div nz-col nzSpan="24">
                <form nz-form nzLayout="vertical" [formGroup]="searchManagerForm">
                  <nz-form-item>
                    <nz-form-label>Ajouter un animateur</nz-form-label>
                    <nz-form-control>
                      <input placeholder="Rechercher" nz-input formControlName="value"
                             [nzAutocomplete]="auto"/>
                      <nz-autocomplete #auto [nzBackfill]="true">
                        <nz-auto-option
                          *ngFor="let user of usersList"
                          [nzValue]="user"
                          [nzLabel]="user.lastName + ' ' + user.firstName"
                        >
                          {{ user.lastName }} {{ user.firstName }}
                        </nz-auto-option>
                      </nz-autocomplete>
                    </nz-form-control>
                  </nz-form-item>
                  <nz-form-item>
                    <nz-form-control>
                      <button type="button" [disabled]="searchManagerForm.get('value').invalid" nz-button
                              nzType="primary"
                              (click)="addManagerToAnEvent()">Ajouter
                      </button>
                    </nz-form-control>
                  </nz-form-item>
                  <nz-form-item>
                    <nz-form-control>
                      <button type="button" nz-button nzType="default"
                              (click)="addManagerToAnEvent(user)">M'ajouter moi même
                      </button>
                    </nz-form-control>
                  </nz-form-item>
                </form>
              </div>
            </div>
            <div nz-row>
              <div nz-col nzSpan="24">
                <app-cruder [service]="organizerService" type="isManager" [other]="fullEvent?.event"></app-cruder>
              </div>
            </div>
          </ng-template>
        </nz-tab>
        <nz-tab *ngIf="user?.isAdmin || user?.isManager" nzTitle="Edition">
          <ng-template nz-tab>
            <form [formGroup]="eventForm" nz-form nzLayout="vertical" (ngSubmit)="saveEvent()">

              <nz-form-item>
                <nz-form-label>Publié</nz-form-label>
                <nz-form-control>
                  <nz-switch formControlName="published"></nz-switch>
                </nz-form-control>
              </nz-form-item>

              <nz-form-item>
                <nz-form-label nzRequired>Date de début</nz-form-label>
                <nz-form-control nzHasFeedback>
                  <nz-date-picker
                    [nzShowTime]="{nzFormat: 'HH:mm'}"
                    nzFormat="dd/MM/yyyy HH:mm"
                    nzPlaceHolder="Choisir un jour et une heure"
                    formControlName="startDate"
                  ></nz-date-picker>
                </nz-form-control>
              </nz-form-item>

              <nz-form-item>
                <nz-form-label nzRequired>Date de fin</nz-form-label>
                <nz-form-control nzHasFeedback>
                  <nz-date-picker
                    [nzShowTime]="{nzFormat: 'HH:mm'}"
                    nzFormat="dd/MM/yyyy HH:mm"
                    nzPlaceHolder="Choisir un jour et une heure"
                    formControlName="endDate"
                  ></nz-date-picker>
                </nz-form-control>
              </nz-form-item>

              <nz-form-item>
                <nz-form-label nzRequired>Adresse Url Réunion</nz-form-label>
                <nz-form-control>
                  <input formControlName="link" nz-input type="text"/>
                </nz-form-control>
              </nz-form-item>

              <nz-form-item>
                <nz-form-label nzRequired>Zoom</nz-form-label>
                <nz-form-control>
                  <input formControlName="camLink" nz-input type="text"/>
                </nz-form-control>
              </nz-form-item>

              <nz-form-item>
                <nz-form-label>Taille max ? oui / non</nz-form-label>
                <nz-form-control>
                  <nz-switch formControlName="maxSizedActivated"></nz-switch>
                </nz-form-control>
              </nz-form-item>

              <nz-form-item *ngIf="eventForm.get('maxSizedActivated').value === true">
                <nz-form-label>Taille maximale</nz-form-label>
                <nz-form-control>
                  <input nz-input type="number" formControlName="maxSize"/>
                </nz-form-control>
              </nz-form-item>

              <!--<nz-form-item>
                <nz-form-label>Ouvert à tous les membres ?</nz-form-label>
                <nz-form-control>
                  <nz-switch formControlName="openToAll"></nz-switch>
                </nz-form-control>
              </nz-form-item>-->

              <nz-form-item>
                <nz-form-control>
                  <button [disabled]="eventForm.invalid" nz-button nzType="primary">Sauver</button>
                </nz-form-control>
              </nz-form-item>

            </form>
          </ng-template>
        </nz-tab>
        <nz-tab *ngIf="user?.isUser && fullEvent.event.state === 'done'" nzTitle="Mon évaluation">
          <ng-template nz-tab>
            <app-satisfaction-survey [eventUid]="fullEvent?.event?.uid" [user]="user"
                                     *ngIf="user?.uid && fullEvent?.event?.uid"></app-satisfaction-survey>
          </ng-template>
        </nz-tab>
        <nz-tab *ngIf="user?.isAdmin || user?.isManager" nzTitle="Évaluations">
          <div nz-row>
            <div nz-col nzSpan="24">
              <ng-template nz-tab>
                <app-cruder [service]="invitedSurveyService" type="isUser" [other]="fullEvent?.event"></app-cruder>
              </ng-template>
            </div>
          </div>
        </nz-tab>
      </nz-tabset>
    </ng-container>
  </app-main-layout>
</nz-spin>
